import { DataObject, VNode } from './VDOM';
export declare class DOMRenderer {
    eventPattern: RegExp;
    ariaPattern: RegExp;
    protected treeCache: WeakMap<Node, VNode>;
    protected keyOf: ({ key, text, props, selector }: VNode, index?: number) => any;
    protected vNodeOf: (list: VNode[], key?: VNode['key']) => VNode;
    protected propsKeyOf: (key: string) => string;
    protected updateProps<N extends DataObject, P extends DataObject>(node: N, oldProps?: P, newProps?: P, onDelete?: (node: N, key: string) => any, onAdd?: (node: N, key: string, value: any) => any): void;
    protected createNode(vNode: VNode, reusedVNodes?: Record<string, VNode[]>): Node;
    protected deleteNode({ ref, node, children }: VNode): void;
    protected commitChildren(root: ParentNode, newNodes: ChildNode[]): void;
    protected updateChildren(node: ParentNode, oldList: VNode[], newList: VNode[]): void;
    patch(oldVNode: VNode, newVNode: VNode): VNode;
    render(vNode: VNode, node?: ParentNode): VNode;
    renderToStaticMarkup(tree: VNode): string;
}
