"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VNode = void 0;
var VNode = /** @class */ (function () {
    function VNode(meta) {
        Object.assign(this, meta);
        var tagName = meta.tagName, is = meta.is, props = meta.props;
        if (!tagName && !(props === null || props === void 0 ? void 0 : props.className) && !is)
            return;
        this.selector = [
            tagName === null || tagName === void 0 ? void 0 : tagName.toLowerCase(),
            (props === null || props === void 0 ? void 0 : props.className) &&
                ".".concat(props.className.trim().replace(/\s+/, '.')),
            is && "[is=\"".concat(is, "\"]")
        ]
            .filter(Boolean)
            .join('');
    }
    VNode.fromDOM = function (node) {
        var _this = this;
        if (node instanceof Text)
            return new _a({ node: node, text: node.nodeValue });
        if (!(node instanceof Element))
            return new _a({ node: node });
        var _b = node, tagName = _b.tagName, attributes = _b.attributes, style = _b.style, childNodes = _b.childNodes;
        var vNode = {
            node: node,
            tagName: tagName.toLowerCase(),
            is: node.getAttribute('is')
        };
        var props = Array.from(attributes, function (_b) {
            var name = _b.name, value = _b.value;
            return name !== 'style' && [_this.attrsMap[name] || name, value];
        }).filter(Boolean);
        if (props[0])
            vNode.props = Object.fromEntries(props);
        var styles = Array.from(style, function (key) { return [key, style[key]]; });
        if (styles[0])
            vNode.style = Object.fromEntries(styles);
        var children = Array.from(childNodes, function (node) { return _a.fromDOM(node); });
        if (children[0])
            vNode.children = children;
        return new _a(vNode);
    };
    var _a;
    _a = VNode;
    VNode.propsMap = {
        className: 'class',
        htmlFor: 'for'
    };
    VNode.attrsMap = Object.fromEntries(Object.entries(_a.propsMap).map(function (item) { return item.reverse(); }));
    return VNode;
}());
exports.VNode = VNode;
